
/*******************************************
/* CheckRx1()
/*******************************************/
void CheckRx1()
{ 
 // Test auf Initialisierungsstring  
    if(Len1 == 14)
     CheckRx1Ini();

    // Test auf Befehlssstring   
    if(Len1 == 12)
     CheckRx1Command();
   
   
 // Nach Behandlung Empfangswerte zurücksetzen   
    Rx1[0] = 0;
    Len1 = 0;
}



/*******************************************
/* CheckRx1Ini()
/*******************************************/
void CheckRx1Ini()
{
  if(Rx1[0] == 0x0d && Rx1[4] == 7)
  {
   Tx07[3] = Rx1[3]; // Zähler setzen 
   Serial1.write(Tx07, 21);  
  }
    
  if(Rx1[0] == 0x0d && Rx1[4] == 2)
  {
   Tx02[3] = Rx1[3]; // Zähler setzen 
   Serial1.write(Tx02, 14);
  }

}

/*******************************************
/* CheckRx1Command()
/*******************************************/
void CheckRx1Command()
{
  byte b, i;
  boolean xChange = false;
  
  
     // Test auf Befehlsstring "Schalten"
     if(Rx1[0] == 0x0b && (Rx1[6] & 0xF0) == 0xD0 && (Rx1[6] & 0x0F) == bDeviceID)
     {
      bX = Rx1[7] & 0x0F;
      bP = Rx1[7];
      bP >>= 4;
      bP &= 0x0F;
      
  
      xOnOff = (boolean)Rx1[9];
      
        if(bQMode[bP][bX] == Schalter)// EIN/AUS
        {
          if( bX % 2 == 1 && bQMode[bP][bX-1] == Motor)
          {// Index/Adresse hier ungerade: Darf nicht von F gesendet werden. Wenn doch, dann wird zurueckgesetzt
           xQ[bP][bX]     = false;
           xQ[bP][bX-1]   = false;
           bQMode[bP][bX] = Motor;
          }
          else
          {
           xQ[bP][bX]     = xOnOff;
           if(xOnOff)
            tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
           else
            tQOn[bP][bX] = 0;
          }
        }
        else
        {
          if(bQMode[bP][bX] == Motor )// Rolllade
          {
            if(bX % 2 == 0)
            {
              bQOnSet[bP][bX+1] = bQOnSet[bP][bX]; 
              
              if(xOnOff)
              { 
               xQ[bP][bX] ^= true;
               xQ[bP][bX+1] = false;
               
               if(xQ[bP][bX])
               {
                tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]); 
                tQOnDelay[bP][bX] = 5;
               }
              }
              else
              {
               xQ[bP][bX] = false;
               xQ[bP][bX+1] ^= true; 
  
               if(xQ[bP][bX+1])
               {
                tQOn[bP][bX+1] = ByteToTime(bQOnSet[bP][bX]);              
                tQOnDelay[bP][bX+1] = 5;
               }
              }
             bQMode[bP][bX+1] = Motor;
            }
            else// Index/Adresse hier ungerade: Darf nicht von F gesendet werden. Wenn doch, dann wird zurÃ¼ckgesetzt
            {
             bQMode[bP][bX-1] = Motor;
             xQ[bP][bX-1] = false;
            }            
          }
        }
     }
   
      // Test auf Befehlstring GetIO
     if(Rx1[0] == 0x0b && (Rx1[4] == 0x0E))
     {
      SendState();
     }
 

}
