/*******************************************
/* SetConfig()
/*******************************************/
boolean SetConfig()
{ String s;
  boolean xOK = false;
  int i;

  
  //Feststellen um welchen Befehl es sich handelt
  
  if(sCmd.indexOf("pw:") == 0) // pw: an 1. Position also Index == 0?
  {// Passwort setzen
   SetPassword();
   xOK = true;
  } 

  if(sCmd.indexOf("sms1:") == 0) // sms1: an 1. Position also Index == 0?
  {// 1. Nummer für SMS setzen
   SetSMS(1);
   xOK = true;
  } 

  if(sCmd.indexOf("sms2:") == 0) // sms2: an 1. Position also Index == 0?
  {// 1. Nummer für SMS setzen
   SetSMS(2);
   xOK = true;
  } 
  
  
  
  if(sCmd.indexOf("id:") == 0) // id: an 1. Position also Index == 0?
  {
   SetID();
   xOK = true;
  }

  if(sCmd.indexOf("twi:") == 0 || sCmd.indexOf("i2c:") == 0 ) // ist Kommando an 1. Position also Index == 0?
  {
   SetTwi();
   xOK = true;
  }   

   if(sCmd.indexOf("alarm:") == 0) // alarm: an 1. Position also Index == 0?
  {
   SetAlarm();
   xOK = true;
  } 

   if(sCmd.indexOf("sps:") == 0) // sps: an 1. Position also Index == 0?
  {
   SetPLC();
   xOK = true;
  }   

  if(sCmd.indexOf("port:") == 0 && sCmd.indexOf("=") == 6) // port: an 1. Position also Index == 0?
  {
   SetPort();
   xOK = true;
  }  
  
  if((sCmd.indexOf("zeit:") == 0 || sCmd.indexOf("mode:") == 0 )&& 
     (sCmd.indexOf("=") == 6 || sCmd.indexOf("=") == 7 || sCmd.indexOf("=") == 8)) // Wegen Merker zeit: an 1. Position also Index == 0?
  {
   ParseZM();
   xOK = true;
  }    
  
  return xOK;
}

/*******************************************
/* ParseZM()
/*******************************************/
void ParseZM()
{ 
  char c[16];
  boolean xChange = false;
  byte bM;

   sCmd.toCharArray(c, sCmd.length() +1 );

 // Feststellen ob es sich um eine Port oder Merkerangabe handelt
 if(c[6] == '.')
 {
   // feststellen ob die Angabe für die Portnummer nummerisch ist
 if(IsNumeric(c[5], '7')) 
  {//ja, Port ist nummerisch 
   if(IsNumeric(c[7], '7')) 
    {//ja, Ausgang ist nummerisch 
        bP = c[5] - 48;
        bX = c[7] - 48;
     // ist der Port ein Ausgang?
     if( Port[bP].Fnc == Ausg)
     {// ja, dann Feststellen ob zeit oder mode
      
      if(sCmd.indexOf("zeit:") == 0)
       SetPortTime();
       
      if(sCmd.indexOf("mode:") == 0)
       SetMode();           
     }
     else
     {
      Serial.print(F("Der angegebene Port "));
      Serial.print(bP);
      Serial.print(F(" ist kein Ausgang")); 
     }
    
    }
    else
    {
     Serial.print(F("Ausgang "));
     Serial.print(bX);
     Serial.print(F(" nicht von 4...7")); 
    }
  }
  else
  {
   Serial.print(F("Port "));
   Serial.print(bX);
   Serial.print(F(" nicht von 0...7")); 
  }
  
 }
 else
 { // Feststellen ob Merkerangabe (weil keine Portangabe)
    if(isDigit(c[5]) && isDigit(c[6])) 
      {// Die Merkeradresse besteht aus 2 Digits

        bM =  (c[5]-48) * 10;
        bM += (c[6]- 48);
        SetFlagTime(bM);

      }
      else
      {
        if(isDigit(c[5]))
       {//Die Merkeradresse besteht aus einem Digit
        bM = (c[5]-48);
        SetFlagTime(bM);
     
      }
      else
      {
       Serial.println(F("Keine Port- oder Merkerangabe"));
     
      } 
    
 }
 }
}

//********************************************************* 
/*******************************************
/* SetMode()
 * mode:1.2=m  Schalter
  s= Schalter m = Motor
/*******************************************/
void SetMode()
{ 
 char c[16];
  boolean xChange = false;
  byte bMode;

 sCmd.toCharArray(c, sCmd.length() +1 );
 
 
 if(c[9] == 's' || c[9] == 'm' )
 {
    //Prüfung fand in ParseZM() statt
   bP = c[5] - 48;
   bX = c[7] - 48;
   
   if(c[9] == 's')
   {
    bMode = Schalter;
    Serial.println(F("Modus s"));
   }
    
   if(c[9] == 'm')
   {
    bMode = Motor;
    Serial.println(F("Modus m")); 
   }
    
    
     if(bQMode[bP][bX] != bMode)
     {
       // aktuell gibt es nur mode 1(s) und 2(m)
        bQMode[bP][bX] = bMode;
        EEPROM.write((bP*8) + bX,  bMode); 
       // Wenn Ausgang gerade 
       if( bX % 2 == 0  )
       {// dann auch den folgenden Ausgang anpassen  
        bQMode[bP][bX+1] = bMode;
        EEPROM.write((bP*8) + bX+1,  bMode);        
       }
       else // wenn ungerade
       {// dann auch den vorherigen Ausgang anpassen  
        bQMode[bP][bX-1] = bMode;
        EEPROM.write((bP*8) + bX-1,  bMode);        
       }       
     } 
     else
     {
     Serial.print(F("Modus "));
     Serial.print(c[9]);
     Serial.println(F(" ist schon eingestellt"));     
    }   
  }
  else
  {
   Serial.print(F("Modus "));
   Serial.print(c[9]);
   Serial.println(F(" unbekannt (s = Schalter, m = Motor)"));     
  }
}



//#########################################################
/*******************************************
/* SetPortTime()
 * zeit:3=25
 * zeit:3=25
/*******************************************/
void SetFlagTime(byte bFlagNbr)
{ 
 char c[16];
  //boolean xChange = false;
  byte bOnSet, bUnit, bFactor, bIndex;

 if( bFlagNbr > 64)
 {
 Serial.println(F("Zeitzuweisungen nur vom Merker 0...63 erlaubt"));
 Serial.println(F("Merker 64...80 sind fuer das Alarmmodul reserviert"));
 return;
 }

  
   sCmd.toCharArray(c, sCmd.length() +1 );

 if(bFlagNbr < 10)
  bIndex = 7;
 else
  bIndex = 8; 
  
 //Zeiteinheit feststellen
 if(IsNumeric(c[bIndex], '6'))
 {
    bUnit = c[bIndex] - 48;
    
    bIndex++;
    
   if(isHexadecimalDigit(c[bIndex])) 
   {// ja 
   
    if(isDigit(c[bIndex]))
     bFactor = c[bIndex] - 48; // nummerischer Wert
    else
     bFactor = c[bIndex] - 87; // durch die vorherige hexadezimal-Prüfung und lower case a-f 
    
    bOnSet = (bUnit * 16)+ bFactor;
    
 //   Serial.print(F("Zeit "));
 //   Serial.println(bOnSet, HEX);
       
    
    
     if(bMOnSet[bFlagNbr] != bOnSet)
      {
       bMOnSet[bFlagNbr] = bOnSet;
       EEPROM.write(EE_FlagTime + bFlagNbr,  bOnSet);
       
       Serial.print(F("Zeit "));
       Serial.print((unsigned long)ByteToTime(bOnSet)/10);
       Serial.print(F(" Sekunden in Merker "));
       Serial.print(bFlagNbr);
       Serial.println(F(" geschrieben"));  
  
     }
    
   }
   else
   {
    Serial.print(F("Faktor "));
    Serial.print(c[10]);
    Serial.println(F(" nicht hexadezimal von 0-F"));  
   }
  }
  else
  {
   Serial.print(F("Zeiteinheit "));
   Serial.print(c[9]);
   Serial.println(F(" nicht von 0-6"));     
  }  


}

/*******************************************
/* SetPortTime()
 * zeit:1.5=25
/*******************************************/
void SetPortTime()
{ 
 char c[16];
  //boolean xChange = false;
  byte bOnSet, bUnit, bFactor;
 sCmd.toCharArray(c, sCmd.length() +1 );
 
 //Zeiteinheit feststellen
 if(IsNumeric(c[9], '6'))
 {
    bUnit = c[9] - 48;
    
   if(isHexadecimalDigit(c[10])) 
   {// ja 
   
    if(c[10] >= '0' && c[10] <= '9')
     bFactor = c[10] - 48; // nummerischer Wert
    else
     bFactor = c[10] - 87; // durch die vorherige hexadezimal-Prüfung und lower case a-f 
    
    bOnSet = (bUnit * 16)+ bFactor;
    
 //   Serial.print(F("Zeit "));
 //   Serial.println(bOnSet, HEX);
    
    //Prüfung fand in ParseZM() statt
     bP = c[5] - 48;
     bX = c[7] - 48;
    
    
    
     if(bQOnSet[bP][bX] != bOnSet)
      {
       bQOnSet[bP][bX] = bOnSet;
       EEPROM.write((bP*8) + 64 + bX,  bOnSet);
       
       Serial.print(F("Zeit "));
       Serial.print((unsigned long)ByteToTime(bOnSet)/10);
       Serial.print(F(" Sekunden in Ausgang "));
       Serial.print(bP);
       Serial.print(".");
       Serial.print(bX);
       Serial.println(F(" geschrieben"));  
  
  
       if(bQMode[bP][bX] == Motor)//Modus Motor
       {//Wenn Ausgang gerade
       if( bX % 2 == 0 )
       {// dann auch den folgenden Ausgang anpassen
        EEPROM.write((bP*8) + 64 + bX + 1,  bOnSet);
        bQOnSet[bP][bX+1] = bOnSet;
       }  
       else //Wenn Ausgang ungerade
       {// dann auch den vorheringen Ausgang anpassen
        EEPROM.write((bP*8) + 64 + bX - 1,  bOnSet);
        bQOnSet[bP][bX-1] = bOnSet;
       }     
      }
     }
    
   }
   else
   {
    Serial.print(F("Faktor "));
    Serial.print(c[10]);
    Serial.println(F(" nicht hexadezimal von 0-F"));  
   }
  }
  else
  {
   Serial.print(F("Zeiteinheit "));
   Serial.print(c[9]);
   Serial.println(F(" nicht von 0-6"));     
  }
   
 
  
}


/*******************************************
/* SetPort()
 * port:4=e5
   port:5=a
   port:6=e
   port:5=g0  Ausgangsport mit normaler Reihenfolge
   port:5=g1  Ausgangsport mit umgekehrter Reihenfolge   
/*******************************************/
void SetPort()
{ 
//  String s;
  char c[16];
  //char cFnc = 0;
  byte b;
  boolean xChange = false;
  boolean x;

   sCmd.toCharArray(c, sCmd.length() +1 ) ;

 // feststellen ob die Angabe für die Portnummer nummerisch ist
 if(IsNumeric(c[5], '7')) 
  {//ja, nummerisch 
      bP = c[5] - 48;
  //Funktion feststellen
  
  if( c[7] == 'a' || c[7] == 'e' || c[7] == 'g'  || c[7] == 'i' || c[7] == 's')
  {
    
   switch(c[7]) 
  {
    /*
    case 'a':
    
       if(Port[bP].Fnc != Ausg)
       {       
         xChange = true;
         
        for(bX=0; bX<=7; bX++)  
        {
         bQMode[bP][bX] = Schalter;
         bQOnSet[bP][bX] = 0;
         EEPROM.write((bP*8) + bX, Schalter); // bQMode
         EEPROM.write((bP*8) + 64 + bX, 0); //  bQOnSet
        }           
       }
            
       Port[bP].Fnc = Ausg;
       Port[bP].Ass = 0xFF;     
    
    
    break;
    */
    case 'e':
    
    // Feststellen ob der Port ein Ausgang ist, der bereits von einem Eingang geschaltet wird.
    // wenn ja, dann Portfunktion nicht ändern
    
     x = true;
    if(Port[bP].Fnc == Ausg)
    {// Port ist ein Ausgang
     x = false;
       Serial.print(F("Achtung! Der Ausgangsport "));
       Serial.print(bP);
       Serial.println(F(" kann nicht als Eingang konfiguriert werden!"));   
          
     for(b=0; b<=3; b++)
     {
      if( Port[b].Fnc == EinAus && Port[b].Ass == bP)
      {
       Serial.print(F("Ausgangsport "));
       Serial.print(bP);
       Serial.print(F(" wird aktuell von Port "));       
       Serial.print(b);
       Serial.println(F(" geschaltet"));
      }
     }  
    }
    
   if(x)
   {    
    if(sCmd.length() == 9)
    {
      if(c[8] >= '4' && c[8] <= '7')  // entspricht Eingang mit Zuweisung auf Ausgang
      {
       b = c[8] - 48;
               
       if(b == 5 && xUseAlarm)
        {
         Serial.println(F("Ausgangsport 5 ist vom Alarmmodul reserviert"));
        }
         else
        {
        if(Port[b].Fnc == Ausg)
        {
        xChange = true;  
       
        for(bX=0; bX<=7; bX++)  
        {
         bQMode[bP][bX] = Schalter;
         bQOnSet[bP][bX] = 0;
         EEPROM.write((bP*8) + bX, Schalter); // bQMode
         EEPROM.write((bP*8) + 64 + bX, 0);   // bQOnSet
        }     
      
        EEPROM.write((bP*2) + 128,   Port[bP].Fnc = EinAus); 
        EEPROM.write((bP*2) + 128+1, Port[bP].Ass = b);     
     
      }
      else
      { 
       Serial.print(F("Port "));
       Serial.print(c[8]);
       Serial.print(F(" ist kein Ausgangsport"));
     } 

      }
    }
    else
    {
     Serial.print(F("Port "));
     Serial.print(c[8]);
     Serial.print(F(" nicht von 4...7"));      
    }
   }
   
    if(sCmd.length() == 8) // Kontakteingang (Tuer/Fenster)

    {
       if(Port[bP].Fnc != Eing)
       {
         xChange = true;
      
        for(bX=0; bX<=3; bX++)  
        {
         bQMode[bP][bX] = Frei;
         bQOnSet[bP][bX] = 0;
         EEPROM.write((bP*8) + bX, Frei); // bQMode
         EEPROM.write((bP*8) + 64 + bX, 0); //  bQOnSet
        } 
       } 

        EEPROM.write((bP*2) + 128,   Port[bP].Fnc = Eing); 
        EEPROM.write((bP*2) + 128+1, Port[bP].Ass = 0x0E);      
   
   }   
   
  }
      
    break;

    case 'g': // Ausgangsreihenfolge
    
    if(Port[bP].Fnc == Ausg) // nur behandeln wenn Ausgang
    {
     if(c[8] == '0')  //Ausgangsreihenfolge normal
     {
      bReverse[bP] = 0;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] Ausgangsreihenfolge normal")); 
     }
    
    
     if(c[8] == '1') //Ausgangsreihenfolge entgegengesetzt
     {
      bReverse[bP] = 1;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] Ausgangsreihenfolge entgegengesetzt"));
     }
     
     if(c[8] == '0' || c[8] == '1')
      EEPROM.write(144 + bP, bReverse[bP]);
     else
     {
       Serial.print(F("Parameter "));
       Serial.print(c[8]);
       Serial.print(F(" unbekannt"));
     }   
    }
    else
    {
     Serial.print(F("Port "));
     Serial.print(bP);
     Serial.println(F(" ist kein Ausgang")); 
    }
    
    break;   

    case 'i': // Port Invertierung
    
     if(c[8] == '0')  //nicht invertiert
     {
      bInverse[bP] = 0;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] nicht invertiert")); 
     }
    
    
     if(c[8] == '1') // invertiert
     {
      bInverse[bP] = 1;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] invertiert"));
     }
     
     if(c[8] == '0' || c[8] == '1')
      EEPROM.write(EE_Inverse + bP, bInverse[bP]);
     else
     {
       Serial.print(F("Parameter "));
       Serial.print(c[8]);
       Serial.print(F(" unbekannt"));
     }   
 
    break;    


    case 's': // Pin-Zustand invertiert senden 
              // ON->OFF
              // OFF->ON
    
     if(c[8] == '0')  //nicht invertiert
     {
      bInverseSend[bP] = 0;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] Zustand nicht invertiert senden")); 
     }
    
    
     if(c[8] == '1') // invertiert
     {
      bInverseSend[bP] = 1;
      Serial.print(F("[Port "));
      Serial.print(bP);
      Serial.println(F("] Zustand invertiert senden"));
     }
     
     if(c[8] == '0' || c[8] == '1')
      EEPROM.write(EE_InverseSend + bP, bInverseSend[bP]);
     else
     {
       Serial.print(F("Parameter "));
       Serial.print(c[8]);
       Serial.print(F(" unbekannt"));
     }   
 
    break;           
    
    }
    
    if(xChange)
    { 
      Serial.println(F("Portkonfiguration gespeichert"));
      for(bP = 0; bP <=7; bP++)
      {
       EEPROM.write((bP*2) + 128+1, Port[bP].Ass);   
      }
      
     IniDDR();
    }
   
   }
   else
   {
    Serial.print(F("Befehl "));
    Serial.print(c[7]);
    Serial.print(F(" unbekannt"));
   
   }
  }
 
  else
   Serial.println(F("Es wurde kein Port von 0-7 angegeben!"));     
}

/*******************************************
/* SetID()
/*******************************************/
void SetID()
{ 
 char c[16];

 sCmd.toCharArray(c, sCmd.length() +1 );
  String s = String(char(218)); // Entspricht Rechteck als Charakter

  if(isHexadecimalDigit(c[3]) && sCmd.length() == 4) 
  {
    
    if(c[3] >= '0' && c[3] <= '9')
     bDeviceID = c[3] - 48; // nummerischer Wert
    else
     bDeviceID = c[3] - 87; // durch die vorherige hexadezimal-Prüfung und lower case a-f     
 
   EEPROM.write(EE_DeviceID, bDeviceID);

   Serial.print(F("Device ID wurde auf "));
   Serial.print(bDeviceID);
   Serial.println(F(" gesetzt")); 
   
   display.setTextColor(BLACK);
   display.setCursor(_DisplayXPosID, 33);   
   display.print(s); // vorherige ID mit schwarzem Rechteck im Display überschreiben 1. Stelle
   display.setCursor(_DisplayXPosID + 6, 33);   
   display.print(s); // 2. Stelle

   display.setTextColor(WHITE);
   display.setCursor(_DisplayXPosID, 33);     
   display.print(bDeviceID);   
  }
  else
   Serial.println(F("Keine ID von 0-9 oder a-f(hexadezimal) angegeben!"));   
  
}

/*******************************************
/* SetTwi()
/*******************************************/
void SetTwi()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
      
    if(c[4] >= '0' && c[4] <= '1')
    {
     if(c[4]== '0')
     {
      TWCR = 0;
      EEPROM.write(EE_Twi,  xTwi = false);
      Serial.print(F("TWI (I2C) ausgeschaltet\r\n)"));
     }
     else
     {
      EEPROM.write(EE_Twi,  xTwi = true);
      Serial.print(F("TWI (I2C) eingeschaltet\r\n"));
      display.ReIniDisplay();
     }
  }
  else
   Serial.println(F("Kein Wert von 0...1 angegeben!"));   
}

/*******************************************
/* SetPassword()
/*******************************************/
void SetPassword()
{
 String s;
 byte len;

 //Zeichen 1 bis 3 abschneiden
 sPlain.remove(0, 3); //ab Index 0 weden 3 Zeichen entfernt

 len= sPlain.length();

 if(len >= 6 && len <=15)
  {
   sPassword = sPlain; 
   sPassword.trim();
   
   WriteStringToEE(EE_Password, sPassword);
   Serial.print(F("Das Passwort wurde auf "));
   Serial.print(sPassword);
   Serial.println(F(" gesetzt"));    
  }
  else
   Serial.println(F("Die Passwortlaenge muss 6 bis 15 Zeichen lang sein")); 
}

/*******************************************
/* SetSMS()
/*******************************************/
void SetSMS(byte b)
{
  byte len;
  
  sCmd.remove(0, 5); 

  len = sCmd.length();

 if(IsStringNumeric(sCmd))
 {
  if(len <= 15)
  {
   if(b == 1)
   {
    SMS_Number1 = sCmd; 
    WriteStringToEE(EE_SMS1, SMS_Number1);
    Serial.print(F("Die 1. SMS-Nummer wurde auf "));
    Serial.print(SMS_Number1);
    Serial.println(F(" gesetzt"));
   } 

   if(b == 2)
   {
    SMS_Number2 = sCmd; 
    WriteStringToEE(EE_SMS2, SMS_Number2);
    Serial.print(F("Die 2. SMS-Nummer wurde auf "));
    Serial.print(SMS_Number2);
    Serial.println(F(" gesetzt"));
   } 
      
  }
  else
   Serial.println(F("Die SMS-Nummer darf maximal 15-stellig sein")); 
 }
 else
  Serial.println(F("Die SMS-Nummer darf nur aus Zahlen bestehen"));
  
}


/*******************************************
/* SetPLC()
/*******************************************/
void SetPLC()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
 
   
  if(IsNumeric(c[4], '1')) 
  {
   xUsePLC = (boolean)(c[4] - 48); // nummerischer Wert
   
   EEPROM.write(EE_UsePLC , xUsePLC);
   
   Serial.print(F("SPS ist "));
   
   if(xUsePLC)
     Serial.println(F("aktiviert")); 
    else   
     Serial.println(F("deaktiviert")); 
  }
  else
   Serial.println(F("Wert ist nicht von 0...1"));   
  
}

/*******************************************
/* SetAlarm()
/*******************************************/
void SetAlarm()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
 byte b,p;
 boolean xUA, xOK = true;
 
   
  if(IsNumeric(c[6], '1')) 
  {
    
   xUA = (boolean)(c[6] - 48); // nummerischer Wert
  
   if(xUA)
   {
    // Feststellen ob Abhängigkeiten wegen Port-Mode bestehen
    // Bei Alarmfunktion wird port 1-3 auf Kontaktabfragender Eingang (24 Eingaenge)gestellt,
    // Port 5 auf Alarm Ausgang. Eingangsports 1-3 dürfen nicht auf Ausgangsport 5 zugreifen

     for(b=0; b<=3; b++)
     {
      if(Port[b].Ass == 5 )
      {
       p = b;
       xOK = false;
      }
     }

     if(!xOK)
     {
      xUA = 0; // Alarmfunktion loeschen
      Serial.print(F("Es besteht eine Schaltzuweisung von Eingangsport "));
      Serial.print(p);
      Serial.println(F(" auf Alarm-Ausgangsport 5"));
     }

   }

      Serial.print(F("Alarmfunktion ist"));

   if(xOK && xUA)
   {
    Serial.println(F(" aktiviert"));
   }
   else
    Serial.println(F(" deaktiviert"));
 
     
  if(xUA != xUseAlarm)   // nur schreiben wenn ungleich
  {
   xUseAlarm = xUA;
   EEPROM.write(EE_UseAlarm, xUA);   
  }
   
  }
  else
   Serial.println(F("Wert ist nicht von 0...1"));
  
}

/*******************************************
/* IsNumeric()
/*******************************************/
boolean IsNumeric(char c, char cMax)
{
  boolean x = false;
  String s;
  int i;
 
  
  i = c - 48;
   s = String(i);
  i = s.toInt(); 
  
  if(c >= '0' && c <= cMax && ((i +48) == c))
   x = true;

  return x;
}

boolean IsStringNumeric(String s)
{
 boolean x = true;
 int len = s.length();
 char c[16];
 byte b;

 s.toCharArray(c, len +1);
/*
 Serial.println();
 Serial.println(len);
 Serial.println(s);
 */
 for( b = 0; b < len; b++)
 {
  /*
  Serial.print(b);
  Serial.print(" ");
  Serial.println(c[b]);
 */ 
  if(!IsNumeric(c[b], '9'))
   x = false;
 }
  
  
 return x;
}
