/*******************************************
/* Alarm()
/*******************************************/
void Alarm()
{
  CheckInputs();
   
    //NOT-AUS betätigt
   if( xM[64] > 0) //NOT-AUS betätigt
   {
    if(xState)
    {
     Serial1.print(F("Status:off"));
    }
    xState = false;
   }
    
     // Die wechselnde Flanke wird im SPS-Programm in den Merker 67 geschrieben
   if( xState == 1 && xM[67] > 0 && bAlarm < 2 && (tPreAlarm == 0 || tPreAlarm > PreAlarmDura))
   //  || tPreAlarm > 100 damit nach dem öffnen des Garagentors die Hauptalarmverzögerung "tPreAlarm" bei anschließendem 
   //  Öffnen eines Normal-Kontakes auf 100 gesetzt werden kann.
   {
    bAlarm = 1;  
    tPreAlarm = PreAlarmDura; 
    Serial1.print(F("Alarm:1")); // Am Lesegerät piept es 1 mal pro sek
    
   }
   
   // Alarmauslösung bei fallender Flanke (Garagentor) und längerer Hauptalarmverzögerung
   // Die fallende Flanke wird im SPS-Programm in den Merker 69 geschrieben
   if( xState == 1 && xM[69] > 0 && bAlarm < 2 && tPreAlarm == 0)
   { 
    bAlarm = 1;  
    tPreAlarm = 1200; 
    Serial1.print(F("Alarm:2")); // Am Lesegerät piept es 1 mal pro 5 sek
   }
 
 if( xState == 0  && xM[70] > 0 ) 
 {// Kontaktauslösung im unscharfen Zustand
  Serial1.print(F("LED:on")); 
  tLED_on = 600;   //  LED Einschaltdauer 60 s
  xLED_on = true; 
 }
  
  
  
  if(xState == false)
  {  
   bAlarm = 0;
   tPreAlarm = 0;
   xExtentedPreAlert = false;
  }
     
  
   xM[72] = xState;// scharf, unscharf

   
  if(bAlarm == 1)
  {
   xM[73] = true;
   // Haupt-Alarm verzögern
   if(xM[65] > 0)
   {

    
    if(!xExtentedPreAlert)
    {
     xExtentedPreAlert = true; 
     tPreAlarm = 300;
    }
   }    
  }
  else
  {
   xM[73] = false;
  }
  
  if(bAlarm == 2 && tMainAlarm > 0)
  {
   xM[74] = true;//Hauptalarm;
  }
  else
   xM[74] = false;      
  
  if(tMainAlarm == 1) 
   Serial1.print(F("Alarm:0"));
}

void SetLED(boolean x)
{
 xLED_on = x;

 if(x)
  tLED_on = 1200;   //  LED Einschaltdauer 120 s
 else
  Serial1.print(F("LED:off"));  
}


boolean CheckInputs()
{
 boolean x = true;
 
  if(xM[66] != 1)
   x = false;

 if(cSlaveID == '1')
 {
  // Das Garagentor muss bei bSlaveID == 1 geschlossen sein
  if(xM[68] != 1)
   x = false;
 }
  
  return x;
}
