/**********************************************************************************
/* Sendet den Zustand des Ausganges der von entsprechenden Eingange getoggelt wird
/* Der Zustand des Einganges (der einen Ausgang schaltet) wird nicht gesendet!
/**********************************************************************************/
void InToOut()
{
  boolean xMultiSend = false;
  byte bMask = 1;
  byte bAss;
  
  bAss = Port[bP].Ass;
    
    for(bX=0; bX<=7; bX++)
    {
     if( (bIR[bP] & bMask) > 0)
     {
      TxVisu[ 0] = 0x0b;
      TxVisu[ 1] = 0x11;  
      TxVisu[ 2] = 0x00;
      TxVisu[ 3] = 0x00;
      TxVisu[ 4] = 0x00;  //bQMode[bAss][bX];
      TxVisu[ 5] = 0x00;  //bQOnSet[bAss][bX];
      TxVisu[ 6] = bDeviceID + 0xD0;
      TxVisu[ 7] = bAss<<4 | bX;
      TxVisu[ 8] = 0x01;
      TxVisu[ 9] = 0x01;
      TxVisu[10] = 0x0f;
      TxVisu[11] = 0x70;
      
      xQ[bAss][bX] ^= true;

      if(bQMode[bAss][bX] == Schalter)
      {
	     if( !xQ[bAss][bX])
        {
 	       TxVisu[9] = 0x00;
 	       TxVisu[10] = 0x00;
         tQOn[bAss][bX] = 0; // für Mode 2
        }
          else
           {
            tQOn[bAss][bX] = ByteToTime(bQOnSet[bAss][bX]); 
           }        
      }
      
  	if(bQMode[bAss][bX] == Motor)// Rollade, Garagentor, Markise, Jalosie
        {
   	  if(bX % 2 == 0 )
	   xQ[bAss][bX+1] = false;
	  else
          {
	         xQ[bAss][bX-1] = false;
	         TxVisu[ 7] = bAss<<4 | (bX-1);
         //TxVisu[ 8] = 0x01;  // Zeile formhalber eingefügt
 	         TxVisu[ 9] = 0x00;
 	         TxVisu[10] = 0x00;
          }
          
           if(xQ[bAss][bX])
           {
            tQOn[bAss][bX] = ByteToTime(bQOnSet[bAss][bX]); 
            tQOnDelay[bAss][bX] = 5;
           }
	}

     xMultiSend = true; 
    }
  
   bMask <<= 1;
  } 
}



/**********************************************************************************
/* Sendet den Zustand des Ausganges
/**********************************************************************************/
void ToOut()
{
  boolean xMultiSend = false;
     
    for(bX=0; bX<=7; bX++)
    {
     if((xQC[bP][bX] && bQMode[bP][bX] == Schalter) || xQR[bP][bX])
     {
      TxVisu[ 0] = 0x0b;
      TxVisu[ 1] = 0x11;  
      TxVisu[ 2] = 0x00;
      TxVisu[ 3] = 0x00;
      TxVisu[ 4] = 0x00;  //bQMode[bP][bX];
      TxVisu[ 5] = 0x00;  //bQOnSet[bP][bX];
      TxVisu[ 6] = bDeviceID + 0xD0;
      TxVisu[ 7] = bP<<4 | bX;
      TxVisu[ 8] = 0x01;
      TxVisu[ 9] = 0x01;
      TxVisu[10] = 0x0f;
      TxVisu[11] = 0x70;
      
    //  xQ[bP][bX] ^= true;

      if(bQMode[bP][bX] == Schalter)
      {
	     if( !xQ[bP][bX])
        {
 	       TxVisu[9] = 0x00;
 	       TxVisu[10] = 0x00;
         tQOn[bP][bX] = 0; // für Mode 2
        }
          else
           {
            tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]); 
           }        
      }
      
  	if(bQMode[bP][bX] == Motor && xQR[bP][bX] == 1)// Rollade, Garagentor, Markise, Jalosie
        {
   	  if(bX % 2 == 0 )
          {
	         xQ[bP][bX+1] = false;
          }
	  else
          {// Ungerades Motor-Bit wird nicht gesendet.
           
	         xQ[bP][bX-1] = false;
	         TxVisu[ 7] = bP<<4 | (bX-1);
           //TxVisu[ 8] = 0x01;  // Zeile formhalber eingefügt
 	         TxVisu[ 9] = 0x00;
 	         TxVisu[10] = 0x00;
          }
          
           if(xQ[bP][bX])
           {
            tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]); 
            tQOnDelay[bP][bX] = 5;
           }
	}

     if(xMultiSend)
      delay(100);
     
     Serial.write(TxVisu, 12);
     Serial1.write(TxVisu, 12);     
     xMultiSend = true; 
    }
  
  } 
}
