void SendState()
{
  byte bMask;
  boolean xPinState;

  for(bP=0; bP<=7; bP++)
  { 
   bMask = 1;
    
    if(Port[bP].Fnc == Ausg || Port[bP].Fnc == Eing)
    {
          
     for(bX=0; bX<=7; bX++)
     {

      TxVisu[ 0] = 0x0b;
      TxVisu[ 1] = 0x11;  
      TxVisu[ 2] = 0x00;
      TxVisu[ 3] = 0x00;
      TxVisu[ 4] = 0x00;  //bQMode[bP][bX];
      TxVisu[ 5] = 0x00;  //bQOnSet[bP][bX];    
      TxVisu[ 6] = bDeviceID + 0xD0;
      TxVisu[ 7] = bP<<4 | bX;
      TxVisu[ 8] = 0x01;
      TxVisu[ 9] = 0x01;
      TxVisu[10] = 0x0f;
      TxVisu[11] = 0x70;

      xPinState = true;      


      if(Port[bP].Fnc == Ausg)
      {
       if(xQ[bP][bX] == 0)
        xPinState = false;
      }

      if(Port[bP].Fnc == Eing)
      {
       if((bI[bP] & bMask) == 0)
        xPinState = false;
      }


     if((xPinState ^ (boolean)bInverseSend[bP]) == 0)
     {
      TxVisu[9]    = 0x00;
      TxVisu[10]   = 0x00;
     }
       

      if(bQMode[bP][bX] != Motor) // Stellung einer Rolllade kann nicht über den Ausgang ermittelt werden
      {
       delay(100);
       Serial.write(TxVisu, 12);
       Serial1.write(TxVisu, 12);
      }
  
  bMask <<= 1;
  } 
  }  
 }
}

/********************************************/
boolean SendInput()
{ 
  boolean xMultiSend = false;
  byte bMask = 1;
  boolean xSend = false;
  boolean xPinState;
  

    
    for(bX=0; bX<=7; bX++)
    {
     if( (bIC[bP] & bMask) > 0)
     {
      TxVisu[ 0] = 0x0b;
      TxVisu[ 1] = 0x11;  
      TxVisu[ 2] = 0x00;
      TxVisu[ 3] = 0x00;
      TxVisu[ 4] = 0x00; // ist beim Eingang immer 0x00  bQMode[bP][bX];
      TxVisu[ 5] = 0x00;
      TxVisu[ 6] = bDeviceID + 0xD0;
      TxVisu[ 7] = bP<<4 | bX;
      TxVisu[ 8] = 0x01;
      TxVisu[ 9] = 0x01;
      TxVisu[10] = 0x0f;
      TxVisu[11] = 0x70;

      xPinState = true;
  
    if((bI[bP] & bMask) == 0)
     {
      xPinState = false;
      tQOn[bP][bX] = 0; // für Mode 2
     }

      
     if((xPinState ^ (boolean)bInverseSend[bP]) == 0)
     {
      TxVisu[9]    = 0x00;
      TxVisu[10]   = 0x00;
     }
     

     if(xMultiSend)
      delay(100);

     Serial.write(TxVisu, 12);
     Serial1.write(TxVisu, 12);
     xMultiSend = true; 
     xSend = true;
    }
  
  bMask <<= 1;
  } 
  
  return xSend;
}

/*******************************************
/* SendHelp()
/*******************************************/
void SendHelp()
{
  Serial.println(F("Allgmein:"));
  Serial.println(F(""));
  Serial.println(F("    Alle Kommandos koennen mit Gross- oder Kleinbuchstaben erfolgen."));
  Serial.println(F("    Intern werden alle Buchstaben in Kleinbuchstaben umgewandelt"));
  Serial.println(F("    Kommandos mit ':' sind Schreibkommandos. Der erlaubte Wertebereich"));
  Serial.println(F("    der einzelnen Kommandos wird in dieser Hilfe in eckigen Klammern angegeben"));
  Serial.println(F("-----------------------------------------------------------------------------------"));
  Serial.println(F("Abfrage-Kommando:"));
  Serial.println(F("hilfe     Kann auch mit 'help' oder'?' aufgerufen werden"));
  Serial.println();
  Serial.println(F("id        Ausgabe der Hardware ID"));
  Serial.println();
  Serial.println(F("info      Ausgabe von Harwareversion, ID, Aufbau und Firmwareversion"));
  Serial.println();
  Serial.println(F("port      Ausgabe von den aktuellen Porteinstellungen."));
  Serial.println(F("           - Eingangsport der Ausgangsport x schaltet"));
  Serial.println(F("           - Kontakteingang (Tuer/Fenster)"));
  Serial.println(F("           - Ausgangsport"));
  Serial.println(F("           - Ausgangsport mit entgegengesetzter Reihenfolge"));
  Serial.println();   
  Serial.println(F("port+     Porteinstellungen mit Ausgabe von Ausgangseigenschaften."));
  Serial.println(F("          (Statt 'port+' kann auch einfach '+' eingegeben werden)"));
  Serial.println(F("           - Modus: Schalter, Motor"));
  Serial.println(F("           - Einschaltdauer"));
  Serial.println();
  Serial.println(F("merker     Kann auch mit 'm' aufgerufen werden"));
  Serial.println(F("           - Ausgabe der Merkernummer 0...80 , Status und Einschaltdauer"));
  Serial.println(F("           - Merker 0 und Merker 65...80 sind fuer das Alarmmodul reserviert"));
  Serial.println(F("           - Im Gegensatz zu Port- und Bitangaben (1.4) wird ein Merker im SPS-"));
  Serial.println(F("             Programm ohne Punkt '.' angegeben. So wird zwischen Port/Bit "));
  Serial.println(F("             und Merker unterscheiden"));
  Serial.println();  
  Serial.println(F("sps       Ausgabe des SPS-Programms"));
  Serial.println(F("-----------------------------------------------------------------------------------"));
  Serial.println(F("Schreib-Kommando:"));  
  Serial.println(F("id:6      Schreibt die ID 6 in die Hardware [0...15]"));
  Serial.println(F("          (Es sind maximal 1024 Ein-/Ausgaenge ansteuerbar)"));
  Serial.println();
  Serial.println(F("port:     Beispiel: port:0=e  Bereich[0...7] [a, e, g, i, s]"));
  Serial.println(F("            Port 0 ist ein Kontakteingangsport (Tuer/Fenster/Tor)"));
  Serial.println();
  Serial.println(F("            port:2=e6"));
  Serial.println(F("            Port 2 ist ein Eingangsport der Ausgangsport 6 schaltet"));
  Serial.println();
  Serial.println(F("            port:4=g0"));
  Serial.println(F("            Port 4 ist ein Ausgangsport mit normaler Reihenfolge"));
  Serial.println();
  Serial.println(F("            port:4=g1"));
  Serial.println(F("            Port 4 ist ein Ausgangsport mit entgegengesetzter Reihenfolge"));
  Serial.println();
  Serial.println(F("            port:3=i0"));
  Serial.println(F("            Port 3 ist nicht invertiert"));
  Serial.println();
  Serial.println(F("            port:3=i1"));
  Serial.println(F("            Port 3 ist invertiert"));
  Serial.println();
  Serial.println(F("            port:3=s0"));
  Serial.println(F("            Port 3 Pinzustand wird nicht invertiert gesendet"));
  Serial.println();
  Serial.println(F("            port:3=s1"));
  Serial.println(F("            Port 3 Pinzustand wird invertiert gesendet"));
  Serial.println();  
  Serial.println(F("mode:     Beispiel: mode:7.4=m   Bereich[3...7] [m, s] (nur Ausgaenge)"));
  Serial.println(F("            Bei Port 7 wird der Ausgang Pin 4 auf Motor (m) gestellt"));
  Serial.println(F("            (Motorantrieb für z.B. Rolladen, Jalousien, Vorhaenge oder Tore)"));  
  Serial.println(F("            Weil bei einem Motor fuer jede Richtung je ein Ausgang"));
  Serial.println(F("            notwendig ist, wird bei gerader Ausgangsnummer (Pin 4) der folgende"));
  Serial.println(F("            Ausgang (Pin 5) automatisch auch auf Motor eingestellt."));
  Serial.println(F("            Bei ungerader Ausgangsnummer wird der vorherige Ausgang automatisch auf"));
  Serial.println(F("            Motor gestellt. So sind pro Motorantrieb immer zwei Ausgaenge auf \"m\" eingestellt"));
  Serial.println();
  Serial.println(F("          Beispiel: mode:6.0=s"));
  Serial.println(F("            Bei Port 6 wird der Ausgang 0 auf Schalter (s) gestellt"));
  Serial.println(F("            Wenn zuvor Motor eingestellt war, dann wird bei gerader Ausgangsnummer"));
  Serial.println(F("            der folgende Ausgang, bei ungerader Ausgangsnummer der vorherige Ausgang"));
  Serial.println(F("            auch auf Schalter gestellt."));
  Serial.println();
  Serial.println(F("zeit:     Beispiel Port/Bit: zeit:1.4=35   1. Zeiteinheit[0...6], 2. Faktor[0...f]"));
  Serial.println(F("            Bei Port 1 wird die Einschaltdauer von Ausgang 4 auf 50 Sekunden gestellt"));
  Serial.println(F("            Der Wert 3 gibt die Zeiteinheit von 10 Sekunden an [0...6]")); 
  Serial.println(F("            0 = unbegrenzt"));
  Serial.println(F("            1 = 0,1 Sekunde"));
  Serial.println(F("            2 = 1   Sekunde"));
  Serial.println(F("            3 = 10  Sekunden"));
  Serial.println(F("            4 = 1   Minute"));
  Serial.println(F("            5 = 10  Minuten"));
  Serial.println(F("            6 = 1   Stunde"));
  Serial.println(F("            Der Wert 5 gibt den Faktor an mit dem die Zeiteinheit multipliziert wird"));
  Serial.println(F("            [0...9] und [a...f]"));  
  Serial.println(F("            Um eine unbegrenzte Einschaltdauer einzustellen muss je eine '0' fuer jeden"));
  Serial.println(F("            Wert eingegeben werden, also zeit:1.4=00"));
  Serial.println();  
  Serial.println(F("            Beispiel Merker: zeit:2=23"));
  Serial.println(F("            In Merker 2 wird die Zeit von 3 Sekunden geschrieben"));
  Serial.println(F("            Merker 65...80 sind fuer das Alarmmodul reserviert"));
  Serial.println();
  Serial.println(F("alarm:1   Schaltet das Alarmmodul ein   [0...1]"));
  Serial.println(F("          Zu dem Alarmmodul muss auch das SPS-Modul eingeschaltet werden, weil ueber das"));
  Serial.println(F("          SPS-Programm die verwendeten Eingaenge (Fernsterkontakte) bestimmt werden"));
  Serial.println();
  Serial.println(F("pw:xxx    Setzt das Transponder-Passwort"));
  Serial.println();  
  Serial.println(F("sps:1     Schaltet das SPS-Modul ein    [0...1]"));
  Serial.println();
  Serial.println(F("sms1:0175..   Setzt die 1. Mobilfunknummer an die eine SMS bei Voralarmausloesung gesendet wird"));
  Serial.println(F("sms2:0163..   Setzt die 2. Mobilfunknummer..."));
  Serial.println();
  Serial.println(F("-----------------------------------------------------------------------------------"));
  Serial.println(F("SPS-Befehle"));
  Serial.println(F(" Eingangs/Merker/Ausgangs-Operatoren (Abfrage)"));
  Serial.println(F("   Logische Verknuepfung"));
  Serial.println(F("    L  LADE   "));
  Serial.println(F("    N  LADE nicht"));
  Serial.println(F("    &  UND"));
  Serial.println(F("    %  UND nicht"));
  Serial.println(F("    |  ODER"));
  Serial.println(F("    !  ODER nicht"));
  Serial.println(F("    X  Exklusiv ODER (XOR)"));
  Serial.println();
  Serial.println(F("   Flankenabfrage (Zustandsaenderung)"));
  Serial.println(F("    S  steigend   (von logisch 0 auf logisch 1)"));
  Serial.println(F("    F  fallend    (von logisch 1 auf logisch 0)"));
  Serial.println(F("    W  wechselnd  (fallend oder steigend)  "));
  Serial.println();
  Serial.println(F("  Ausgangs/Merker-Operatoren (Zuweisung):"));
  Serial.println(F("   =  IST  Zuweisung des VKE (Verknüpfungsergebnis)"));
  Serial.println(F("   #  IST nicht (Zuweisung des invertierten VKE"));
  Serial.println(F("   E  EIN (klassisches Setzen wenn VKE logisch 1 ist)"));
  Serial.println(F("   A  AUS (klassisches Ruecksetzen wenn VKE logisch 1 ist)"));
  Serial.println(F("   I  Invertiert den Zustand des Ausganges"));
  Serial.println();
  Serial.println(F(" Operanden"));
  Serial.println(F("  Ein-/Ausgaenge werden mit Port.Bit also mit '.' angesprochen"));
  Serial.println(F("   E/A  [0.0 ... 7.7]"));
  Serial.println(F("  Merker werden ohne '.' angegeben"));
  Serial.println(F("   M  [0...80]"));

  /*Die Ausgabe dauert ca. 1,5 Sekunden
   *Der Watchdog ist auf 2s eingestellt. Sollte hier noch mehr eingetragen werden, 
   *dann sollte hier der Watchdog geresettet werden 
   */

  // wdt_reset();
}

/*******************************************
/* SendID()
/*******************************************/
void SendID()
{
  Serial.print(F("Device ID: "));
  Serial.println(bDeviceID);
}

/*******************************************
/* SendAlarm()
/*******************************************/
void SendAlarm()
{
  Serial.print(F("Alarmfunktion: "));

  if(xUseAlarm)
  {
   Serial.println(F("aktiviert"));
   Serial.print(F("1. SMS-Alarmierung: "));
   Serial.println(SMS_Number1);
   Serial.print(F("2. SMS-Alarmierung: "));
   Serial.println(SMS_Number2);   
  }
  else
   Serial.println(F("deaktiviert"));
    
}


/*******************************************
/* SendPLC(boolean x)
// b == false  --> nur Status de/-aktiviert senden
// b == true  --> Status und SPS-Programm senden
/*******************************************/
void SendPLC(boolean x)
{
  Serial.print(F("SPS      : "));

  if(xUsePLC)
   Serial.println(F("aktiviert"));
  else
   Serial.println(F("deaktiviert"));
   
 if(x)
  SendPGM(); 
    
}

/*******************************************
/* SendPGM()
/*******************************************/
void SendPGM()
{
  unsigned int i;
  boolean xIsAllocation = false;
  byte b;

  Serial.print(F("Programmlaenge: "));
  Serial.print(iPLCend + 1);
  Serial.println(" Byte");
  Serial.println(F("SPS-Programm:"));
  Serial.println("{");
  

  for(i=0; i<=iPLCend; i++)
  {
   //Hier resetten wird den WatchDogTimer, falls das SPS-Programm sehr lang ist
   wdt_reset();
   
   //Befehl feststellen
   //High-Nibble
   b = (byte)cPLC[i] & B11110000;


/*
   Serial.println();
   Serial.print(" i=");
   Serial.print(i);
   Serial.print("  v=");
   Serial.print(b, DEC);

   Serial.print("  BIN ");
   Serial.print(b, BIN);
      
   Serial.print("-> ");
  */ 

 if( b == _l || b == _ln || b == _u || b == _un || b == _o || b == _on || b == _x)
 {
   if(xIsAllocation)
    Serial.println();

  xIsAllocation = false;
 }
 
switch (b) 
    {
     
     case _ln: // Lade nicht
     Serial.print("N");
     break;       
   
      
     case _u: // und
     Serial.print("&"); 
     break;
  
     
     case _un: // und nicht
     Serial.print("%");; 
     break;     
  
    
     case _o: // oder
     Serial.print("|"); 
     break;
  
  
     case _on: // oder nicht
     Serial.print("!"); 
     break;  
 
 
     case _x: // xor
     Serial.print("X"); 
     break;         
   
    } 
//////////////////////////////////
// Zuweisung

 if( b == _ist || b == _istn || b == _e || b == _a || b == _i)
 {

  xIsAllocation = true;
 }
 
switch (b) 
    {
      
   
     case _ist: // Lade
     Serial.print("=");
     break;  
  
     
     case _istn: // Lade nicht
     Serial.print("#");
     break;       
   
      
     case _e: // ein
     Serial.print("E"); 
     break;
  
     
     case _a: // aus
     Serial.print("A");; 
     break;     
  
  
     case _i: // invertiere
     Serial.print("I"); 
     break;  
       
   
    } 


 if(cPLC[i] == 0)
  Serial.print("L");
//////////////////////////////////

   // Befehl feststellen
   //Low-Nibble
  b = (byte)cPLC[i] & B00001111;
  
 if( b == _s || b == _f || b == _w)
 {
   if(xIsAllocation)
    Serial.println();

  xIsAllocation = false;
 }
 
switch (b) 
    {
      /*
     case _l: // Lade
     Serial.print("L");
     break;
*/
     case _s: // steigende Flanke
     Serial.print("S");
     break;       

     case _f: // fallende Flanke
     Serial.print("F");
     break;  


     case _w: // wechselnde Flanke
     Serial.print("W");
     break;       
    }





  i++;

  // ab hier operand feststellen
  if((cPLC[i] & B10000000) > 0)
  {// Merker
   Serial.print((cPLC[i] & B01111111), DEC);

    
  }
  else
  {//Port
   Serial.print(((cPLC[i] & B00111000) >> 3), DEC);
   Serial.print(".");
   Serial.print((cPLC[i] & B00000111), DEC);

    
  }

  
     
  }  

     Serial.println();
     Serial.println("}");
}

/*******************************************
/* SendInfo()
/*******************************************/
void SendInfo()
{
  byte b;

  
  Serial.print(F("Automatisierungsmodul: RFXtrx Emulator"));
  Serial.println(sVersion);

  Serial.print(F("ID       : "));
  Serial.print(bDeviceID);
  Serial.println(F(" [0..15]  HEX[0...F]")); 

  Serial.print(F("TWI      : "));
    
 if(xTwi)
  Serial.println(F("Ein"));
 else
  Serial.println(F("Aus")); 
  
  SendPLC(false);
  SendAlarm();
  
  Serial.print(F("Anzahl der Ports: "));
  Serial.println(bBoardType >>3);
  Serial.print(F("Anzahl der Ein/Ausgaenge: "));
  Serial.println(bBoardType);
  Serial.println();
 
/*  
  Serial.println(F("Konfiguration"));
  Serial.print(F("Befehl : 0b 11 00 00 0C"));
   
   
  for( b = 0; b <= 7; b++)
  {
          if(b % 2 == 0)
       Serial.print(F(" "));
       
    switch(Port[b].Fnc)
    {

      
     case EinAus: 
      Serial.print(Port[b].Ass);
     break;
     
     case Ausg:
      Serial.print(F("A"));
     break;
     
     case Eing:
      Serial.print(F("E"));
     break;
     
     case 255:
      Serial.print(F("F"));
     break;     
    }
  }

  Serial.println(F(" 01 0F 70"));
  Serial.println(F("Rahmung: 0b 11 00 00 .. .. .. .. .. 01 0F 70"));
  Serial.println();  

*/
}








/*******************************************
/* SendFlag
/*******************************************/
void SendFlag()
{ 
  byte b, x; 
  unsigned long uLong;
  float f;  
  
    

    Serial.println(F("Merker Status  Einschaltdauer"));


   for( x = 0; x <= 80; x++)
   {
    Serial.print(F("  "));
    
    if(x<10)
     Serial.print(F(" ")); 
     
    Serial.print(x);

    Serial.print(F( "      "));
    Serial.print(xM[x]);
    
  
   if(bMOnSet[x] > 0)
   {
    uLong = ByteToTime(bMOnSet[x]);
    f = (float)uLong;
    f /= 10;
    
    Serial.print("    ");
    
    Serial.print(f);

    Serial.print(F(" Sekunden (HEX "));
    
    if(bMOnSet[x] < 0xFF)
     Serial.print(bMOnSet[x], HEX);
    else
     Serial.print("00");
    
    Serial.print(F(") "));
   }
   else
    Serial.print(F("    unbegrenzt ")); 
   
    
    switch(x)
    {
     
     case 64:
      Serial.print(F(" Eingang NOT-AUS"));
     break;  
      
     case 65:
      Serial.print(F(" Eingang Hauptalarm verzoegern"));
     break;  
  
     case 66:
      Serial.print(F(" Normalkontakte (UND)"));
     break;  
 
 
     case 67:
      Serial.print(F(" Normalkontakte (FLANKE)"));
     break;
     
     case 68:
      Serial.print(F(" Spezialkontakte (UND)"));
     break;
     
     case 69:
      Serial.print(F(" Spezialkontakte (FLANKE)"));
     break;
     
     case 70:
      Serial.print(F(" Terminal LED EIN (FLANKE)"));
     break;     
     
     case 72:
      Serial.print(F(" Ausgang scharf"));
     break; 
     
     case 73:
      Serial.print(F(" Ausgang Voralarm"));
     break; 

     case 74:
      Serial.print(F(" Ausgang Hauptalarm"));
     break;     
     
    }
    
    Serial.println();

  }   
    
}


/*******************************************
/* SendPort
/*******************************************/
void SendPort(boolean xIO)
{ 
  byte b, x; 
  unsigned long uLong;
  float f;  
  
  
 for( b = 0; b <= 7; b++)
  {
   Serial.print(F("[Port "));
   Serial.print(b);
   Serial.print(F("]:"));
   
   
   switch( Port[b].Fnc )
   {

     
   case EinAus:
    Serial.print(F(" Eingangsport der Ausgangsport "));
    Serial.print(Port[b].Ass);
    Serial.print(F(" schaltet"));

     if(bInverse[b] == 1)
      Serial.print(F( " invertiert"));  
      
     if(bInverseSend[b] == 1)
      Serial.print(F( " Zustand wird invertiert gesendet"));
   

    if(xIO)
    { 
     Serial.println();      
     Serial.print(F(" -Status Eingaenge [0...7] "));
     Serial.print(IOStatus(b));
    }  
   break;
   
   case Ausg:   
    Serial.print(F(" Ausgangsport"));
 

     if(bInverse[b] == 1)
      Serial.print(F( " invertiert"));
    
    if( bReverse[b] == 1)
     Serial.print(F(" mit entgegengesetzter Reihenfolge"));

     if(bInverseSend[b] == 1)
      Serial.print(F( " Zustand wird invertiert gesendet"));     
 
  if(xIO)
  {   
    Serial.println();
    

    Serial.println(F(" -Ausgang Status  Modus     Einschaltdauer"));


   for( x = 0; x <= 7; x++)
   {
    Serial.print(F("     "));
    Serial.print(x);

    Serial.print(F( "       "));
    Serial.print(xQ[b][x]);
    
    

    Serial.print(F( "   "));
    
    if(bQMode[b][x] == Schalter)
     Serial.print(F( "Schalter"));
     
        if(bQMode[b][x] == Motor)
     Serial.print(F( " Motor  ")); 
     
    Serial.print(F( "  "));

   if(bQOnSet[b][x] > 0)
   {
    uLong = ByteToTime(bQOnSet[b][x]);
    f = (float)uLong;
    f /= 10;
    
     Serial.print("  ");
    
    Serial.print(f);

    Serial.print(F(" Sekunden (HEX "));
    
    
    Serial.print(bQOnSet[b][x], HEX);

    Serial.print(F(") "));
   }
   else
    Serial.print(F("  unbegrenzt "));
    
    if(x!=7)
     Serial.println();   

  }
   break;   
   
   case Eing:
    Serial.print(F(" Kontakteingang (Tuer/Fenster)"));

     if(bInverse[b] == 1)
      Serial.print(F( " invertiert"));

     if(bInverseSend[b] == 1)
      Serial.print(F( " Zustand wird invertiert gesendet"));      
          
    if(xIO)
    { 
     Serial.println();      
     Serial.print(F(" -Status Eingaenge [0...7] "));
     Serial.print(IOStatus(b));
    }     
   break; 

   case 255:
    Serial.print(F(" unbenutzt"));
   break;   

  }
 }
  
  if(xIO)
   Serial.println();
   
  Serial.println();  
  
  
 }    
}

/*******************************************
/* IOStatus
 *  Erzeigt den aktuellen Status der Eingänge als String
 */
/*******************************************/
String IOStatus( byte p)
{ 
  String s;
  byte b, bMask;

  bMask = 1;

   for( b = 0; b <= 7; b++)
   {
   
    if((bI[p] & bMask) == 0)
     s += " 0";
    else
     s += " 1";

     bMask *= 2; 
   }

   return s;
}
